import{S as gs,i as ks,s as ys,e as n,k as i,w as S,t as U,M as js,c as o,d as e,m as f,a as r,x as E,h as B,b as l,G as a,g as p,y as P,L as bs,q as A,o as x,B as z,v as qs}from"../chunks/vendor-hf-doc-builder.js";import{I as rs,C as ls}from"../chunks/CodeBlock-hf-doc-builder.js";function Ss(ps){let h,I,c,u,L,w,Y,N,Z,R,b,ss,J,m,_,C,$,es,G,ts,O,g,T,q,as,D,k,F,d,v,H,y,ns,M,os,K,j,Q;return w=new rs({}),$=new rs({}),g=new ls({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    for k in f.keys():
        tensors[k] = f.get_tensor(k)`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> f.keys():
        tensors[k] = f.get_tensor(k)`}}),k=new ls({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    tensor_slice = f.get_slice("embedding")
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    tensor_slice = f.get_slice(<span class="hljs-string">&quot;embedding&quot;</span>)
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`}}),y=new rs({}),j=new ls({props:{code:`import torch
from safetensors.torch import save_file

tensors = {
    "embedding": torch.zeros((2, 2)),
    "attention": torch.zeros((2, 3))
}
save_file(tensors, "model.safetensors")`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> safetensors.torch <span class="hljs-keyword">import</span> save_file

tensors = {
    <span class="hljs-string">&quot;embedding&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)),
    <span class="hljs-string">&quot;attention&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">3</span>))
}
save_file(tensors, <span class="hljs-string">&quot;model.safetensors&quot;</span>)`}}),{c(){h=n("meta"),I=i(),c=n("h1"),u=n("a"),L=n("span"),S(w.$$.fragment),Y=i(),N=n("span"),Z=U("Safetensors"),R=i(),b=n("p"),ss=U("Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy)."),J=i(),m=n("h2"),_=n("a"),C=n("span"),S($.$$.fragment),es=i(),G=n("span"),ts=U("Load tensors"),O=i(),S(g.$$.fragment),T=i(),q=n("p"),as=U("Loading only part of the tensors (interesting when running on multiple GPU)"),D=i(),S(k.$$.fragment),F=i(),d=n("h2"),v=n("a"),H=n("span"),S(y.$$.fragment),ns=i(),M=n("span"),os=U("Save tensors"),K=i(),S(j.$$.fragment),this.h()},l(s){const t=js('[data-svelte="svelte-1phssyn"]',document.head);h=o(t,"META",{name:!0,content:!0}),t.forEach(e),I=f(s),c=o(s,"H1",{class:!0});var V=r(c);u=o(V,"A",{id:!0,class:!0,href:!0});var is=r(u);L=o(is,"SPAN",{});var fs=r(L);E(w.$$.fragment,fs),fs.forEach(e),is.forEach(e),Y=f(V),N=o(V,"SPAN",{});var hs=r(N);Z=B(hs,"Safetensors"),hs.forEach(e),V.forEach(e),R=f(s),b=o(s,"P",{});var cs=r(b);ss=B(cs,"Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy)."),cs.forEach(e),J=f(s),m=o(s,"H2",{class:!0});var W=r(m);_=o(W,"A",{id:!0,class:!0,href:!0});var ms=r(_);C=o(ms,"SPAN",{});var ds=r(C);E($.$$.fragment,ds),ds.forEach(e),ms.forEach(e),es=f(W),G=o(W,"SPAN",{});var us=r(G);ts=B(us,"Load tensors"),us.forEach(e),W.forEach(e),O=f(s),E(g.$$.fragment,s),T=f(s),q=o(s,"P",{});var _s=r(q);as=B(_s,"Loading only part of the tensors (interesting when running on multiple GPU)"),_s.forEach(e),D=f(s),E(k.$$.fragment,s),F=f(s),d=o(s,"H2",{class:!0});var X=r(d);v=o(X,"A",{id:!0,class:!0,href:!0});var vs=r(v);H=o(vs,"SPAN",{});var ws=r(H);E(y.$$.fragment,ws),ws.forEach(e),vs.forEach(e),ns=f(X),M=o(X,"SPAN",{});var $s=r(M);os=B($s,"Save tensors"),$s.forEach(e),X.forEach(e),K=f(s),E(j.$$.fragment,s),this.h()},h(){l(h,"name","hf:doc:metadata"),l(h,"content",JSON.stringify(Es)),l(u,"id","safetensors"),l(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(u,"href","#safetensors"),l(c,"class","relative group"),l(_,"id","load-tensors"),l(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(_,"href","#load-tensors"),l(m,"class","relative group"),l(v,"id","save-tensors"),l(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(v,"href","#save-tensors"),l(d,"class","relative group")},m(s,t){a(document.head,h),p(s,I,t),p(s,c,t),a(c,u),a(u,L),P(w,L,null),a(c,Y),a(c,N),a(N,Z),p(s,R,t),p(s,b,t),a(b,ss),p(s,J,t),p(s,m,t),a(m,_),a(_,C),P($,C,null),a(m,es),a(m,G),a(G,ts),p(s,O,t),P(g,s,t),p(s,T,t),p(s,q,t),a(q,as),p(s,D,t),P(k,s,t),p(s,F,t),p(s,d,t),a(d,v),a(v,H),P(y,H,null),a(d,ns),a(d,M),a(M,os),p(s,K,t),P(j,s,t),Q=!0},p:bs,i(s){Q||(A(w.$$.fragment,s),A($.$$.fragment,s),A(g.$$.fragment,s),A(k.$$.fragment,s),A(y.$$.fragment,s),A(j.$$.fragment,s),Q=!0)},o(s){x(w.$$.fragment,s),x($.$$.fragment,s),x(g.$$.fragment,s),x(k.$$.fragment,s),x(y.$$.fragment,s),x(j.$$.fragment,s),Q=!1},d(s){e(h),s&&e(I),s&&e(c),z(w),s&&e(R),s&&e(b),s&&e(J),s&&e(m),z($),s&&e(O),z(g,s),s&&e(T),s&&e(q),s&&e(D),z(k,s),s&&e(F),s&&e(d),z(y),s&&e(K),z(j,s)}}}const Es={local:"safetensors",title:"Safetensors"};function Ps(ps){return qs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class zs extends gs{constructor(h){super();ks(this,h,Ps,Ss,ys,{})}}export{zs as default,Es as metadata};
